package en_US;

###############################################################################
# Greymatter
# Copyright (c)2000-2008, The Greymatter team 
# http://greymatterforum.proboards82.com/     
# By possessing this software, you agree not to hold the author responsible for 
# any problems that may arise from your installation or usage of Greymatter 
# itself, or from any content generated by yourself or others through the use of 
# this program.  You <I>may</I> freely modify and redistribute this program, so 
# long as every copyright notice (including in this manual and in the Greymatter 
# code) remains fully intact.  Finally, you may <I>not</I> sell or in any way 
# make a financial profit from this program, either in original or modified form.
# Your possession of this software signifies that you agree to these terms; 
# please delete your copy of this software if you don't agree to these terms.
# Original Creators Noah Grey
###############################################################################

# IMPORTANT
# This may be used as a template file.  Copy this file to a new name with the locale
#  you wish to translate to.  For this to be loaded by the current file based GreyMatter
#  the locale names MUST be two lowercase letters + '_' two lowercase or uppercase letters + '.pm'
#  or offically: ISO language code + '_' + ISO Country Code, e.g. en_US
# 
# ONLY CHANGE the very first line from 'en_us' to the name of the new file, without
#  the '.pm' at the end
# ONLY CHANGE the LANGUAGE constant, using the format 
#  'language name (english version)', e.g. 'Espanol (Spanish)'.
# ONLY CHANGE everything between TRANSLATE BEGIN and TRANSLATE END.  Change 
#  only the text between the ' characters, e.g. 'Yes' to 'Si'
# BEWARE single quotes (the ' character), as that will end the string early, so
#  if you have a "author's", it must be "author\'s"
# DO NOT change any word starting with the dollar sign, e.g. $AUTHOR.  It is used
#  by Greymatter and must not be changed

use strict;
use warnings;
use Gm_Constants;

use constant LANGUAGE => 'English';

my %labels = ();

##################################
### - TRANSLATE BEGIN

$labels{ Gm_Constants::ADD } = 'Add';
$labels{ Gm_Constants::DELETE } = 'Delete';
$labels{ Gm_Constants::YES } = 'Yes';
$labels{ Gm_Constants::NO } = 'No';
$labels{ Gm_Constants::EDIT } = 'Edit';
$labels{ Gm_Constants::ACTION } = 'Action';
$labels{ Gm_Constants::NAME } = 'Name';
$labels{ Gm_Constants::PW } = 'Password';
$labels{ Gm_Constants::RETURN_MAIN_MENU } = 'Return To Main Menu';

$labels{ Gm_Constants::SECTION_NO_ACCESS } = '$AUTHOR attempted to access a part of the site without authorization';
$labels{ Gm_Constants::SECTION_ACCESS_DENY } = 'You don\'t have access to this section of the site.';

$labels{ Gm_Constants::SEARCHING } = 'searching';
$labels{ Gm_Constants::COMMENTING } = 'commenting';
$labels{ Gm_Constants::ACCESS_ADMIN } = 'accessing admin screens';

$labels{ Gm_Constants::BANNED_ACCESS } = 'A banned IP ( $IP $HOST ) attempted: $ACTION';
$labels{ Gm_Constants::BANNED_DENY } = 'You have been banned from $ACTION (IP: $IP).';

$labels{ Gm_Constants::LOGIN_NO_ACCESS } = '$AUTHOR attempted to log in without authorization';
$labels{ Gm_Constants::LOGIN_ACCESS_DENY } = 'You don\'t have access to log in.';
$labels{ Gm_Constants::LOGIN_TITLE } = 'Login Prompt';
$labels{ Gm_Constants::LOGIN_AUTHOR } = 'Author';
$labels{ Gm_Constants::LOGIN_ENTER } = 'Enter';
$labels{ Gm_Constants::LOGIN_INVALID_LOG } = 'Invalid login attempt: One or more fields left blank ($AUTHOR $PASSWORD)';
$labels{ Gm_Constants::LOGIN_INVALID } = 'You left one or more of the fields blank.  Please try again.';
$labels{ Gm_Constants::LOGIN_BAD_NAME_LOG } = 'Invalid login attempt: No such author as $AUTHOR ($PASSWORD) registered';
$labels{ Gm_Constants::LOGIN_BAD_NAME } = 'No such author is registered.  Please try again.';
$labels{ Gm_Constants::LOGIN_BAD_PW_LOG } = 'Invalid login attempt: Incorrect password ($PASSWORD) for $AUTHOR';
$labels{ Gm_Constants::LOGIN_BAD_PW } = 'The password you entered for that author is incorrect.  Please try again.';
$labels{ Gm_Constants::LOGIN_LOG } = '$AUTHOR logged in';
$labels{ Gm_Constants::LOGIN_WELCOME } = 'Welcome, $AUTHOR.';
$labels{ Gm_Constants::LOGIN_FIRST } = 'Welcome to Greymatter!  Please enter Configuration first, check your paths, and run Diagnostics & Repair to validate your installation.';
$labels{ Gm_Constants::RELOGIN } = 'Please re-enter under your new author name and password.';

$labels{ Gm_Constants::FRONTPAGE_TITLE } = 'Main Menu';
$labels{ Gm_Constants::FRONTPAGE_ADDNEW } = 'Add A New Entry';
$labels{ Gm_Constants::FRONTPAGE_ADDNEW_DESC } = 'Post a new entry to your weblog/journal.';
$labels{ Gm_Constants::FRONTPAGE_CONFIG } = 'Configuration';
$labels{ Gm_Constants::FRONTPAGE_CONFIG_DESC } = 'Your site\'s settings and options.';
$labels{ Gm_Constants::FRONTPAGE_EDIT } = 'Edit An Entry';
$labels{ Gm_Constants::FRONTPAGE_EDIT_DESC } = 'Edit entries and edit/delete comments.';
$labels{ Gm_Constants::FRONTPAGE_TEMPL } = 'Edit Templates';
$labels{ Gm_Constants::FRONTPAGE_TEMPL_DESC } = 'Change your site\'s layout and appearance.';
$labels{ Gm_Constants::FRONTPAGE_AUTHORS } = 'Edit Authors';
$labels{ Gm_Constants::FRONTPAGE_AUTHORS_DESC } = 'Edit or add authors to post to your site.';
$labels{ Gm_Constants::FRONTPAGE_REBUILD } = 'Rebuild Files';
$labels{ Gm_Constants::FRONTPAGE_REBUILD_DESC } = 'Regenerate part or all of your site.';
$labels{ Gm_Constants::FRONTPAGE_CPLOG } = 'View Control Panel Log';
$labels{ Gm_Constants::FRONTPAGE_CPLOG_DESC } = 'A record of how your site\'s been used.';
$labels{ Gm_Constants::FRONTPAGE_BMLETS } = 'Add Bookmarklets';
$labels{ Gm_Constants::FRONTPAGE_BMLETS_DESC } = 'Post entries with one click (javascript required).';
$labels{ Gm_Constants::FRONTPAGE_UPLOAD } = 'Upload Files';
$labels{ Gm_Constants::FRONTPAGE_UPLOAD_DESC } = 'Upload images or other files to your site.';
$labels{ Gm_Constants::FRONTPAGE_BANNED } = 'Edit Banned IP List';
$labels{ Gm_Constants::FRONTPAGE_BANNED_DESC } = 'Ban someone from using your site.';
$labels{ Gm_Constants::FRONTPAGE_RELOGIN } = 'Re-Login';
$labels{ Gm_Constants::FRONTPAGE_RELOGIN_DESC } = 'Re-enter as another author.';
$labels{ Gm_Constants::FRONTPAGE_VISIT } = 'Visit Your Site';
$labels{ Gm_Constants::FRONTPAGE_VISIT_DESC } = 'Open your weblog/journal in a new browser window.';

$labels{ Gm_Constants::CPLOG_NO_ACCESS } = '$AUTHOR attempted to access the control panel log without authorization';
$labels{ Gm_Constants::CPLOG_ACCESS_DENY } = 'You don\'t have access to the control panel log.';
$labels{ Gm_Constants::CPLOG_TITLE } = 'Control Panel Log';
$labels{ Gm_Constants::CPLOG_INFO_TITLE } = 'Site Stats as of $DATE';
$labels{ Gm_Constants::CPLOG_INFO1 } = '$ENTRYNUMBER entries currently online ($ENTRYOPEN open and $ENTRYCLOSED closed) with $ENTRYARCHIVE archived and $ENTRYCURRENT marked as current';
$labels{ Gm_Constants::CPLOG_INFO2 } = '$KARMAVOTES karma votes cast ($KARMAAVERAGE on average per entry) with $KARMAPOS positive and $KARMANEG negative for a total karma rating of $KARMATOTAL';
$labels{ Gm_Constants::CPLOG_INFO3 } = '$COMMENTTOTAL total comments posted ($COMMENTAVERAGE on average per entry)';
$labels{ Gm_Constants::CPLOG_RESET } = 'Reset The Control Panel Log';
$labels{ Gm_Constants::CPLOG_CLEARED } = '$AUTHOR cleared this control panel log';
$labels{ Gm_Constants::CPLOG_CLEAR_CONFIRM } = 'The control panel log has been cleared.';

$labels{ Gm_Constants::BANIP_NO_ACCESS } = '$AUTHOR attempted to edit the ban list without authorization';
$labels{ Gm_Constants::BANIP_ACCESS_DENY } = 'You don\'t have access to edit the ban list.';
$labels{ Gm_Constants::BANIP_TITLE } = 'Edit Banned IP List';
$labels{ Gm_Constants::BANIP_INFO } = 'Anyone matching an IP address that you have listed here will be unable to vote or post comments on your site; you can optionally add names to them to help you remember who you\'ve banned.  You can also ban partial IPs (for example, banning 12.34.56 would ban someone at 12.34.56.78 as well as 12.34.56.89).';
$labels{ Gm_Constants::BANIP_IP } = 'IP';
$labels{ Gm_Constants::BANIP_HOST } = 'Host';
$labels{ Gm_Constants::BANIP_ADD_TITLE } = 'Add a New Banned IP Entry';
$labels{ Gm_Constants::BANIP_ADD_NAME } = 'Banned person\'s name (optional)';
$labels{ Gm_Constants::BANIP_ENTER_IP } = 'You must enter the IP you want to add to the ban list.';
$labels{ Gm_Constants::BANIP_DUPE_IP } = 'That IP is already in the ban list.';
$labels{ Gm_Constants::BANIP_ADDED } = '$AUTHOR added an IP ( $IP $NAME ) to the ban list';
$labels{ Gm_Constants::BANIP_ADD_CONFIRM } = '$IP has been added to the ban list.';
$labels{ Gm_Constants::BANIP_SELECT_IP } = 'You must select the IP you want to delete from the ban list.';
$labels{ Gm_Constants::BANIP_DELETED } = '$AUTHOR deleted an IP ( $IP $LABEL ) from the ban list';
$labels{ Gm_Constants::BANIP_DELETE_CONFIRM } = '$IP has been deleted from the ban list.';

$labels{ Gm_Constants::AUTHORS_NO_ACCESS } = '$AUTHOR attempted to edit the authors without authorization';
$labels{ Gm_Constants::AUTHORS_ACCESS_DENY } = 'You don\'t have access to edit the authors.';
$labels{ Gm_Constants::AUTHORS_ALICE_ALERT } = 'Be sure to create your own author and delete Alice!';
$labels{ Gm_Constants::AUTHORS_TITLE } = 'Author Panel';
$labels{ Gm_Constants::AUTHORS_INFO } = 'Select an author to edit their information and/or access, or to delete them altogether.';
$labels{ Gm_Constants::AUTHORS_PRIVS } = 'Privileges';
$labels{ Gm_Constants::AUTHORS_ADD_TITLE } = 'Register A New Author';
$labels{ Gm_Constants::AUTHORS_ADD_INFO } = 'Create a new account for someone to have access to Greymatter with (giving an e-mail or homepage is optional).  You can specify whether the author is created having access to everything, to nothing, or to post & edit their own entries only; you can then customise their access further by editing their account above after it\'s been created.';
$labels{ Gm_Constants::AUTHORS_EMAIL } = 'E-Mail';
$labels{ Gm_Constants::AUTHORS_HOMEPAGE } = 'Homepage';
$labels{ Gm_Constants::AUTHORS_DEF_ACCESS } = 'Default Author Access';
$labels{ Gm_Constants::AUTHORS_ALL_ACCESS } = 'All access';
$labels{ Gm_Constants::AUTHORS_NO_ACCESS } = 'No access';
$labels{ Gm_Constants::AUTHORS_OWN_ACCESS } = 'Post & edit their own entries only';
$labels{ Gm_Constants::AUTHORS_OWN_SHORT } = 'Post & Edit Own';
$labels{ Gm_Constants::AUTHORS_CUSTOM_ACCESS } = 'Custom';
$labels{ Gm_Constants::AUTHORS_ENTER_NAME_PW } = 'You left either the name or password fields blank.  Please try again.';
$labels{ Gm_Constants::AUTHORS_NOWS_NAME_PW } = 'You cannot have a space at the beginning or end of the author name or password.  Please try again.';
$labels{ Gm_Constants::AUTHORS_BAD_NAME_PW } = 'The author name or password cannot contain non-alphanumeric characters (characters other than letters, numbers or spaces).  Please try again.';
$labels{ Gm_Constants::AUTHORS_DUPE_NAME } = 'That author is already registered.';
$labels{ Gm_Constants::AUTHORS_DUPE_LOG } = '$AUTHOR attempted to add an author that is already registered ($NAME)';
$labels{ Gm_Constants::AUTHORS_ADD_LOG } = '$AUTHOR registered a new author ($NAME)';
$labels{ Gm_Constants::AUTHORS_ADD_CONFIRM } = '$NAME has been added to the author database.';
$labels{ Gm_Constants::AUTHORS_SELECT_NAME } = 'You must select an author first.';
$labels{ Gm_Constants::AUTHORS_NO_DELETE } = 'You can\'t delete the only remaining author!';
$labels{ Gm_Constants::AUTHORS_DELETE_LOG } = '$AUTHOR deleted an author ($NAME)';
$labels{ Gm_Constants::AUTHORS_DELETE_CONFIRM } = '$NAME has been deleted.';
$labels{ Gm_Constants::AUTHORS_EDIT_TITLE } = 'Editing $AUTHOR\'s  Info & Access';
$labels{ Gm_Constants::AUTHORS_STATS } = 'This author was created on $CREATED and has written $ENTRIES entries.';
$labels{ Gm_Constants::AUTHORS_CAN_POST } = 'Can post new entries?';
$labels{ Gm_Constants::AUTHORS_CAN_EDIT } = 'Can edit entries?';
$labels{ Gm_Constants::AUTHORS_ONLY_OWN } = 'Only their own entries';
$labels{ Gm_Constants::AUTHORS_CAN_CONFIG } = 'Can configure?';
$labels{ Gm_Constants::AUTHORS_CAN_TEMPLATES } = 'Can edit templates?';
$labels{ Gm_Constants::AUTHORS_ONLY_HEAD } = 'Only header/footer/sidebar';
$labels{ Gm_Constants::AUTHORS_CAN_AUTHORS } = 'Can edit authors?';
$labels{ Gm_Constants::AUTHORS_CAN_REBUILD } = 'Can rebuild files?';
$labels{ Gm_Constants::AUTHORS_CAN_CPLOG } = 'Can view CP log?';
$labels{ Gm_Constants::AUTHORS_CAN_BM } = 'Can use bookmarklets?';
$labels{ Gm_Constants::AUTHORS_CAN_UPLOAD } = 'Can upload files?';
$labels{ Gm_Constants::AUTHORS_CAN_LOGIN } = 'Can login to gm.cgi?';
$labels{ Gm_Constants::AUTHORS_SAVE_CHANGES } = 'Save Changes To This Author';
$labels{ Gm_Constants::AUTHORS_OVERWRITE_LOG } = '$AUTHOR attempted to change to duplicate of $NEWNAME via $NAME';
$labels{ Gm_Constants::AUTHORS_OVERWRITE_NAME } = 'You can\'t change the name of an existing author to duplicate of another author.';
$labels{ Gm_Constants::AUTHORS_NEWNAME_LOG } = '$AUTHOR changed $NAME\'s name to $NEWNAME';
$labels{ Gm_Constants::AUTHORS_NO_CHANGES } = 'No changes were made to $NAME.';
$labels{ Gm_Constants::AUTHORS_EDIT_LOG } = '$AUTHOR edited $NAME\'s info/access';
$labels{ Gm_Constants::AUTHORS_EDIT_CONFIRM } = '$NAME\'s info/access has been edited.';


$labels{ Gm_Constants::ENTRIES_NO_ACCESS } = '$AUTHOR attempted to edit the entries without authorization';
$labels{ Gm_Constants::ENTRIES_ACCESS_DENY } = 'You don\'t have access to edit the entries.';











### - TRANSLATE END
##################################

## Get Labels
# Method to allow access to this langauge label hash.
## DO NOT TOUCH THIS DURING TRANSLATION
sub getLabels {
 return \%labels;
}

1;
